<?php declare(strict_types=1);

namespace Sharkk\Router;

interface SegmentRouterInterface extends RouterInterface
{
    //private function addNode(array &$node, array $segments, string $method, callable $handler): void;
    public static function clear(array &$routes): void;
    //public static function dump(array &$routes): array; // Deprecated, routes are now passed by reference
    public static function get(array &$routes, string $route, callable $handler): void;
    public static function post(array &$routes, string $route, callable $handler): void;
    public static function put(array &$routes, string $route, callable $handler): void;
    public static function patch(array &$routes, string $route, callable $handler): void;
    public static function delete(array &$routes, string $route, callable $handler): void;
    public static function head(array &$routes, string $route, callable $handler): void;
}